// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Describes a Virtual Machine Image.
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class VirtualMachineImageInner : VirtualMachineImageResourceInner
    {
        /// <summary>
        /// Initializes a new instance of the VirtualMachineImageInner class.
        /// </summary>
        public VirtualMachineImageInner() { }

        /// <summary>
        /// Initializes a new instance of the VirtualMachineImageInner class.
        /// </summary>
        /// <param name="name">the name of the resource.</param>
        /// <param name="location">the location of the resource.</param>
        /// <param name="tags">the tags attached to the resource.</param>
        public VirtualMachineImageInner(string name, string location, string id = default(string), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), PurchasePlan plan = default(PurchasePlan), OSDiskImage osDiskImage = default(OSDiskImage), System.Collections.Generic.IList<DataDiskImage> dataDiskImages = default(System.Collections.Generic.IList<DataDiskImage>))
            : base(name, location, id, tags)
        {
            Plan = plan;
            OsDiskImage = osDiskImage;
            DataDiskImages = dataDiskImages;
        }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.plan")]
        public PurchasePlan Plan { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.osDiskImage")]
        public OSDiskImage OsDiskImage { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.dataDiskImages")]
        public System.Collections.Generic.IList<DataDiskImage> DataDiskImages { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public override void Validate()
        {
            base.Validate();
            if (this.Plan != null)
            {
                this.Plan.Validate();
            }
            if (this.OsDiskImage != null)
            {
                this.OsDiskImage.Validate();
            }
        }
    }
}
