// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// The instance view of a virtual machine scale set.
    /// </summary>
    public partial class VirtualMachineScaleSetInstanceViewInner
    {
        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineScaleSetInstanceViewInner class.
        /// </summary>
        public VirtualMachineScaleSetInstanceViewInner() { }

        /// <summary>
        /// Initializes a new instance of the
        /// VirtualMachineScaleSetInstanceViewInner class.
        /// </summary>
        /// <param name="virtualMachine">the instance view status summary for
        /// the virtual machine scale set.</param>
        /// <param name="extensions">the extensions information.</param>
        /// <param name="statuses">the resource status information.</param>
        public VirtualMachineScaleSetInstanceViewInner(VirtualMachineScaleSetInstanceViewStatusesSummary virtualMachine = default(VirtualMachineScaleSetInstanceViewStatusesSummary), System.Collections.Generic.IList<VirtualMachineScaleSetVMExtensionsSummary> extensions = default(System.Collections.Generic.IList<VirtualMachineScaleSetVMExtensionsSummary>), System.Collections.Generic.IList<InstanceViewStatus> statuses = default(System.Collections.Generic.IList<InstanceViewStatus>))
        {
            VirtualMachine = virtualMachine;
            Extensions = extensions;
            Statuses = statuses;
        }

        /// <summary>
        /// Gets the instance view status summary for the virtual machine
        /// scale set.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "virtualMachine")]
        public VirtualMachineScaleSetInstanceViewStatusesSummary VirtualMachine { get; private set; }

        /// <summary>
        /// Gets the extensions information.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "extensions")]
        public System.Collections.Generic.IList<VirtualMachineScaleSetVMExtensionsSummary> Extensions { get; private set; }

        /// <summary>
        /// Gets or sets the resource status information.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "statuses")]
        public System.Collections.Generic.IList<InstanceViewStatus> Statuses { get; set; }

    }
}
