// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// IPConfiguration in a NetworkInterface
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class NetworkInterfaceIPConfigurationInner : Microsoft.Azure.Management.Resource.Fluent.SubResource
    {
        /// <summary>
        /// Initializes a new instance of the
        /// NetworkInterfaceIPConfigurationInner class.
        /// </summary>
        public NetworkInterfaceIPConfigurationInner() { }

        /// <summary>
        /// Initializes a new instance of the
        /// NetworkInterfaceIPConfigurationInner class.
        /// </summary>
        /// <param name="applicationGatewayBackendAddressPools">Gets or sets
        /// the reference of ApplicationGatewayBackendAddressPool
        /// resource</param>
        /// <param name="loadBalancerBackendAddressPools">Gets or sets the
        /// reference of LoadBalancerBackendAddressPool resource</param>
        /// <param name="loadBalancerInboundNatRules">Gets or sets list of
        /// references of LoadBalancerInboundNatRules</param>
        /// <param name="privateIPAllocationMethod">Gets or sets PrivateIP
        /// allocation method. Possible values include: 'Static',
        /// 'Dynamic'</param>
        /// <param name="privateIPAddressVersion">Gets or sets PrivateIP
        /// address version (IPv4/IPv6). Possible values include: 'IPv4',
        /// 'IPv6'</param>
        /// <param name="primary">Gets whether this is a primary customer
        /// address on the NIC</param>
        /// <param name="name">Gets name of the resource that is unique within
        /// a resource group. This name can be used to access the
        /// resource</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated</param>
        public NetworkInterfaceIPConfigurationInner(string id = default(string), System.Collections.Generic.IList<ApplicationGatewayBackendAddressPoolInner> applicationGatewayBackendAddressPools = default(System.Collections.Generic.IList<ApplicationGatewayBackendAddressPoolInner>), System.Collections.Generic.IList<BackendAddressPoolInner> loadBalancerBackendAddressPools = default(System.Collections.Generic.IList<BackendAddressPoolInner>), System.Collections.Generic.IList<InboundNatRuleInner> loadBalancerInboundNatRules = default(System.Collections.Generic.IList<InboundNatRuleInner>), string privateIPAddress = default(string), string privateIPAllocationMethod = default(string), string privateIPAddressVersion = default(string), SubnetInner subnet = default(SubnetInner), bool? primary = default(bool?), PublicIPAddressInner publicIPAddress = default(PublicIPAddressInner), string provisioningState = default(string), string name = default(string), string etag = default(string))
            : base(id)
        {
            ApplicationGatewayBackendAddressPools = applicationGatewayBackendAddressPools;
            LoadBalancerBackendAddressPools = loadBalancerBackendAddressPools;
            LoadBalancerInboundNatRules = loadBalancerInboundNatRules;
            PrivateIPAddress = privateIPAddress;
            PrivateIPAllocationMethod = privateIPAllocationMethod;
            PrivateIPAddressVersion = privateIPAddressVersion;
            Subnet = subnet;
            Primary = primary;
            PublicIPAddress = publicIPAddress;
            ProvisioningState = provisioningState;
            Name = name;
            Etag = etag;
        }

        /// <summary>
        /// Gets or sets the reference of ApplicationGatewayBackendAddressPool
        /// resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.applicationGatewayBackendAddressPools")]
        public System.Collections.Generic.IList<ApplicationGatewayBackendAddressPoolInner> ApplicationGatewayBackendAddressPools { get; set; }

        /// <summary>
        /// Gets or sets the reference of LoadBalancerBackendAddressPool
        /// resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.loadBalancerBackendAddressPools")]
        public System.Collections.Generic.IList<BackendAddressPoolInner> LoadBalancerBackendAddressPools { get; set; }

        /// <summary>
        /// Gets or sets list of references of LoadBalancerInboundNatRules
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.loadBalancerInboundNatRules")]
        public System.Collections.Generic.IList<InboundNatRuleInner> LoadBalancerInboundNatRules { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.privateIPAddress")]
        public string PrivateIPAddress { get; set; }

        /// <summary>
        /// Gets or sets PrivateIP allocation method. Possible values include:
        /// 'Static', 'Dynamic'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.privateIPAllocationMethod")]
        public string PrivateIPAllocationMethod { get; set; }

        /// <summary>
        /// Gets or sets PrivateIP address version (IPv4/IPv6). Possible
        /// values include: 'IPv4', 'IPv6'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.privateIPAddressVersion")]
        public string PrivateIPAddressVersion { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.subnet")]
        public SubnetInner Subnet { get; set; }

        /// <summary>
        /// Gets whether this is a primary customer address on the NIC
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.primary")]
        public bool? Primary { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.publicIPAddress")]
        public PublicIPAddressInner PublicIPAddress { get; set; }

        /// <summary>
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets name of the resource that is unique within a resource group.
        /// This name can be used to access the resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets a unique read-only string that changes whenever the
        /// resource is updated
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

    }
}
