// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// A NetworkInterface in a resource group
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class NetworkInterfaceInner : Microsoft.Azure.Management.Resource.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the NetworkInterfaceInner class.
        /// </summary>
        public NetworkInterfaceInner() { }

        /// <summary>
        /// Initializes a new instance of the NetworkInterfaceInner class.
        /// </summary>
        /// <param name="virtualMachine">Gets or sets the reference of a
        /// VirtualMachine</param>
        /// <param name="networkSecurityGroup">Gets or sets the reference of
        /// the NetworkSecurityGroup resource</param>
        /// <param name="ipConfigurations">Gets or sets list of
        /// IPConfigurations of the network interface</param>
        /// <param name="dnsSettings">Gets or sets DNS settings in network
        /// interface</param>
        /// <param name="macAddress">Gets the MAC address of the network
        /// interface</param>
        /// <param name="primary">Gets whether this is a primary NIC on a
        /// virtual machine</param>
        /// <param name="enableIPForwarding">Gets or sets whether IPForwarding
        /// is enabled on the NIC</param>
        /// <param name="resourceGuid">Gets or sets resource guid property of
        /// the network interface resource</param>
        /// <param name="provisioningState">Gets provisioning state of the
        /// PublicIP resource Updating/Deleting/Failed</param>
        /// <param name="etag">Gets a unique read-only string that changes
        /// whenever the resource is updated</param>
        public NetworkInterfaceInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), Microsoft.Azure.Management.Resource.Fluent.SubResource virtualMachine = default(Microsoft.Azure.Management.Resource.Fluent.SubResource), NetworkSecurityGroupInner networkSecurityGroup = default(NetworkSecurityGroupInner), System.Collections.Generic.IList<NetworkInterfaceIPConfigurationInner> ipConfigurations = default(System.Collections.Generic.IList<NetworkInterfaceIPConfigurationInner>), NetworkInterfaceDnsSettings dnsSettings = default(NetworkInterfaceDnsSettings), string macAddress = default(string), bool? primary = default(bool?), bool? enableIPForwarding = default(bool?), string resourceGuid = default(string), string provisioningState = default(string), string etag = default(string))
            : base(location, id, name, type, tags)
        {
            VirtualMachine = virtualMachine;
            NetworkSecurityGroup = networkSecurityGroup;
            IpConfigurations = ipConfigurations;
            DnsSettings = dnsSettings;
            MacAddress = macAddress;
            Primary = primary;
            EnableIPForwarding = enableIPForwarding;
            ResourceGuid = resourceGuid;
            ProvisioningState = provisioningState;
            Etag = etag;
        }

        /// <summary>
        /// Gets or sets the reference of a VirtualMachine
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.virtualMachine")]
        public Microsoft.Azure.Management.Resource.Fluent.SubResource VirtualMachine { get; set; }

        /// <summary>
        /// Gets or sets the reference of the NetworkSecurityGroup resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.networkSecurityGroup")]
        public NetworkSecurityGroupInner NetworkSecurityGroup { get; set; }

        /// <summary>
        /// Gets or sets list of IPConfigurations of the network interface
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.ipConfigurations")]
        public System.Collections.Generic.IList<NetworkInterfaceIPConfigurationInner> IpConfigurations { get; set; }

        /// <summary>
        /// Gets or sets DNS settings in network interface
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.dnsSettings")]
        public NetworkInterfaceDnsSettings DnsSettings { get; set; }

        /// <summary>
        /// Gets the MAC address of the network interface
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.macAddress")]
        public string MacAddress { get; set; }

        /// <summary>
        /// Gets whether this is a primary NIC on a virtual machine
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.primary")]
        public bool? Primary { get; set; }

        /// <summary>
        /// Gets or sets whether IPForwarding is enabled on the NIC
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.enableIPForwarding")]
        public bool? EnableIPForwarding { get; set; }

        /// <summary>
        /// Gets or sets resource guid property of the network interface
        /// resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.resourceGuid")]
        public string ResourceGuid { get; set; }

        /// <summary>
        /// Gets provisioning state of the PublicIP resource
        /// Updating/Deleting/Failed
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

    }
}
