// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Resource.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Deployment dependency information.
    /// </summary>
    public partial class Dependency
    {
        /// <summary>
        /// Initializes a new instance of the Dependency class.
        /// </summary>
        public Dependency() { }

        /// <summary>
        /// Initializes a new instance of the Dependency class.
        /// </summary>
        /// <param name="dependsOn">The list of dependencies.</param>
        /// <param name="id">The ID of the dependency.</param>
        /// <param name="resourceType">The dependency resource type.</param>
        /// <param name="resourceName">The dependency resource name.</param>
        public Dependency(System.Collections.Generic.IList<BasicDependency> dependsOn = default(System.Collections.Generic.IList<BasicDependency>), string id = default(string), string resourceType = default(string), string resourceName = default(string))
        {
            DependsOn = dependsOn;
            Id = id;
            ResourceType = resourceType;
            ResourceName = resourceName;
        }

        /// <summary>
        /// Gets or sets the list of dependencies.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "dependsOn")]
        public System.Collections.Generic.IList<BasicDependency> DependsOn { get; set; }

        /// <summary>
        /// Gets or sets the ID of the dependency.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the dependency resource type.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "resourceType")]
        public string ResourceType { get; set; }

        /// <summary>
        /// Gets or sets the dependency resource name.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "resourceName")]
        public string ResourceName { get; set; }

    }
}
