// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Resource.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Previewed feature information.
    /// </summary>
    public partial class FeatureResultInner
    {
        /// <summary>
        /// Initializes a new instance of the FeatureResultInner class.
        /// </summary>
        public FeatureResultInner() { }

        /// <summary>
        /// Initializes a new instance of the FeatureResultInner class.
        /// </summary>
        /// <param name="name">Gets or sets the name of the feature.</param>
        /// <param name="properties">Gets or sets the properties of the
        /// previewed feature.</param>
        /// <param name="id">Gets or sets the Id of the feature.</param>
        /// <param name="type">Gets or sets the type of the feature.</param>
        public FeatureResultInner(string name = default(string), FeatureProperties properties = default(FeatureProperties), string id = default(string), string type = default(string))
        {
            Name = name;
            Properties = properties;
            Id = id;
            Type = type;
        }

        /// <summary>
        /// Gets or sets the name of the feature.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the properties of the previewed feature.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties")]
        public FeatureProperties Properties { get; set; }

        /// <summary>
        /// Gets or sets the Id of the feature.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the type of the feature.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

    }
}
